<template src="./datatableComponent.htm"></template>

<script>

    import Vue from 'vue';
    import ElementUI from 'element-ui';
    import 'element-ui/lib/theme-chalk/index.css';
    import lang from 'element-ui/lib/locale/lang/en';
    import locale from 'element-ui/lib/locale';
    import SelectComponent from '../inputs/SelectComponent.vue';
    import ImageComponent from '../inputs/ImageComponent.vue';

    import { DataTablesServer } from 'vue-data-tables';

    locale.use(lang);

    Vue.use(ElementUI);

    Vue.component('select-component', SelectComponent);
    Vue.component('image-component', ImageComponent);

    export default {

        created() {

            this.chunkSearchColumns(this.searchColumns);

            this.setInitialSearchParams();
        },

        mounted() {

            eventBus.$on('entity-deleted', () => this.resetComponentKey++);
        },

        data() {

            return {

                resetComponentKey: 0,

                search: {

                    columns: [],

                    initialSearchParams: null
                },

                table: {

                    data: [],

                    filters: [],

                    total: 0,

                    customTitles: this.customColumns,

                    titles: this.tableColumns,

                    actionCol: this.actionColumns,

                    currentPage: 1,

                    pageSize: 5,

                    paginationProps: {

                        pageSizes: [ 5, 10, 20, 50, 100 ]
                    },

                    tableProps: {

                        defaultSort: {

                            prop: '',

                            order: ''
                        },

                        height: '500px',

                        'overflow-x': 'hidden',

                        'overflow-y': 'scroll'
                    }
                }
            }
        },

        props: {

            searchColumns: { type: Array,  default: () => [] },

            customColumns: { type: Array, default: () => [] },

            tableColumns: { type: Array, default: () => [] },

            actionColumns: { type: Object, default() {

                return {

                    label: 'Action',

                    props: {

                        // css properties of table column
                    },

                    buttons: [

                        {
                            props: {

                                class: 'm-portlet__nav-link btn m-btn m-btn--hover-accent m-btn--icon m-btn--icon-only m-btn--pill',
                                icon: 'la la-edit'
                            },

                            handler: (row) => {

                                this.$emit('edit-row', row);
                            },

                            tooltip: 'Edit'
                        },

                        {
                            props: {

                                class: 'm-portlet__nav-link btn m-btn m-btn--hover-danger m-btn--icon m-btn--icon-only m-btn--pill',
                                icon: 'la la-trash'
                            },

                            handler: (row) => {

                                this.$emit('delete-row', row);
                            },

                            tooltip: 'Delete'
                        }
                    ]
                }
            }},

            routeName: { type: String, default: () => '' },

            routeParams: { type: Object, default: () => {} },
        },

        components: { DataTablesServer },

        methods: {

            /**
             * Set initial params and change url.
             */
            setInitialSearchParams() {

                const params = parseUrlParams();

                this.table.tableProps.defaultSort.order = params.sortType === 'ASC' ? 'ascending' : 'descending';

                if (Object.keys(params).length > 0) {

                    this.search.initialSearchParams         = params;
                    this.table.currentPage                  = parseInt(params.page);
                    this.table.pageSize                     = parseInt(params.perPage);
                    this.table.tableProps.defaultSort.prop  = params.sortParam;

                    this.setDefaultSearchParams(params);
                }
            },


            /**
             * Set default values for search inputs and value bind.
             *
             * @param params
             */
            setDefaultSearchParams(params) {

                this.search.columns.forEach( (el) => el.forEach( (el) => {

                    if (params.hasOwnProperty(el.prop)) {

                        if (! el.hasOwnProperty('value')) {

                            Vue.set(el, 'value', params[el.prop]);

                        } else {

                            el.value = params[el.prop];
                        }

                        Vue.set(el, 'default', params[el.prop]);
                    }
                }));
            },


            /**
             * Split array into chunks.
             *
             * @param array
             * @param size
             * @return {Array}
             */
            chunk(array, size) {

                const chunkedArr = [];

                let index = 0;

                while (index < array.length) {

                    chunkedArr.push(array.slice(index, size + index));

                    index += size;
                }

                return Array.isArray(chunkedArr[0]) ? chunkedArr : [chunkedArr];
            },


            /**
             * Depending on count of search columns define max number of search inputs per row.
             *
             * @param searchColumns
             */
            chunkSearchColumns(searchColumns) {

                let size = searchColumns.length % 2 === 0 ? 4 : 3;

                this.search.columns = this.chunk(searchColumns, size);
            },


            /**
             * On submit search add filters to data table in order to trigger queryChange().
             */
            submitSearch() {

                const array                     = [];
                this.search.initialSearchParams = null;

                this.search.columns.forEach( (el) => el.forEach( (el) => array.push({ prop: el.prop, value: el.value })));

                this.table.filters = array;
            },


            /**
             * Reset search criteria.
             */
            resetSearch() {

                formatUrlParams({});

                this.search.columns.forEach( (el) => el.forEach( (el) => el.value = ''));

                this.resetDataTablesServerComponent();
            },


            /**
             * Reset component using :key incrementing.
             */
            resetDataTablesServerComponent() {

                this.resetTableSearchParams();

                this.resetComponentKey += 1;
            },


            /**
             * Reset all table search params (sort, filters).
             */
            resetTableSearchParams() {

                this.table.filters                      = [];
                this.table.tableProps.defaultSort.order = '';
                this.table.tableProps.defaultSort.prop  = '';
            },


            /**
             * On query params change or search form submit load new data.
             *
             * @param info
             */
            queryChange(info) {

                let query = {};

                if (this.search.initialSearchParams !== null) {

                    query                           = this.search.initialSearchParams;
                    this.search.initialSearchParams = null;

                } else {

                    query = {
                        page: info.page,
                        perPage: info.pageSize,
                        sortParam: typeof info.sort.prop !== 'undefined' && info.sort.prop !== null && info.sort.order !== null ? info.sort.prop : null,
                        sortType: typeof info.sort.prop !== 'undefined' && info.sort.prop !== '' && info.sort.prop !== null && info.sort.order !== null ? info.sort.order === 'ascending' ? 'ASC' : 'DESC' : null
                    };

                // Push filters values to query
                    info.filters.forEach( (el) => typeof el.value !== 'undefined' && el.value !== '' && el.value !== null ? query[el.prop] = el.value : null);

                    formatUrlParams(query);
                }

                this.loadData(query);
            },


            /**
             * Fetch data for data table.
             *
             * @param query
             */
            loadData(query) {

                this.table.data = [];

                this.setEntityLoadingStatus(this.routeName + '-datatable', true);

                return axios.get(route(this.routeName, _.merge(query, this.routeParams)))

                    .then((response) => {

                        this.table.total    = response.data.meta.total;
                        this.table.data     = response.data.data;
                    })

                    .catch((errors) => console.log(errors))

                    .then( () => this.setEntityLoadingStatus(this.routeName + '-datatable', false))
            }
        },

        computed: {

            /**
             * Check if data table is in loading state.
             *
             * @return {*}
             */
            dataTableLoading() {

                return this.$store.state.loads[this.routeName + '-datatable'];
            }
        }
    }

</script>